SystemOrganization addCategory: #'Khami-Platform'!
SystemOrganization addCategory: #'Khami-Platform-Facebook'!
SystemOrganization addCategory: #'Khami-Platform-Internal'!
SystemOrganization addCategory: #'Khami-Platform-Sample'!

WASystemConfiguration subclass: #SPConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

!SPConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 19:33'!
describeOn: conf
	(conf collection: #platforms)
		group: #socialPlatform;
		options: [ self platformClasses ].! !

!SPConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 19:28'!
platformClasses
	^SPPlatform allSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

WASystemConfiguration subclass: #SPFacebookConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Facebook'!

!SPFacebookConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 19:50'!
describeOn:  config
	(config string: #facebookApplicationId)
		group: #socialPlatform;
		comment: 'Facebook Application ID'.
		
	(config string: #facebookSecret)
		group: #socialPlatform;
		comment: 'Facebook Application Secret'.
		
	(config url: #facebookCanvasPage)
		group: #socialPlatform;
		comment: 'Facebook Canvas Page Url'! !

WASystemConfiguration subclass: #SPInternalConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

WAComponent subclass: #SPFacebookAuthorizeComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Facebook'!

!SPFacebookAuthorizeComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 10:08'!
appId
	^self application preferenceAt: #facebookApplicationId! !

!SPFacebookAuthorizeComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 10:05'!
authorizeUrl
	^'https://www.facebook.com/dialog/oauth?client_id={1}&redirect_uri={2}' 
		format: {self appId. self canvasPage}! !

!SPFacebookAuthorizeComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 10:09'!
canvasPage
	^self application preferenceAt: #facebookCanvasPage! !

!SPFacebookAuthorizeComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 10:07'!
renderContentOn: html
	html script:  ('top.location.href=''{1}''' format: {self authorizeUrl}) ! !

WAComponent subclass: #SPInternalLoginComponent
	instanceVariableNames: 'name password message users sessions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:34'!
initialize
	super initialize.
	password := nil.
	name := nil.
	users := SPInternalUser.
	sessions := SPInternalSession.! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:26'!
loginAs: user
	| s |
	s := sessions sessionForUser: user.  
	self requestContext response addCookie: s cookie.
	"Expire the Seaside session to force a restart, which should then pick up the cookie"
	self session unregister.! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:19'!
password
	^password! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:07'!
password: aPassword
	password := aPassword! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/5/2011 17:44'!
playerName
	^name! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/5/2011 17:44'!
playerName: aName
	name := aName! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:33'!
renderContentOn: html
	| id |
	self renderMessageOn: html.
	(html form)
		defaultAction: [ self validateUser ];
		with: [ 
					html paragraph:[
						html text: 'Please log in or '.
						html anchor callback: [self call: SPInternalRegistrationComponent new]; with: 'register'.
						html text: '.']. 
					(html label)
						for: (id := html nextId);
						with: 'Username'.
					(html textInput)
						on: #playerName of: self;
						id: id.
					html break.
					(html label)
						for: (id := html nextId);
						with: 'Password'.
					(html passwordInput)
						on: #password of: self;
						id: id.
					html submitButton callback: [ self validateUser ] ]! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:18'!
renderMessageOn: html
	message
		ifNotNil: [ 
			(html paragraph)
				class: 'message';
				with: message ]! !

!SPInternalLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:48'!
validateUser
	message := nil.
	name isEmptyOrNil ifTrue: [^self].
	password isEmptyOrNil ifTrue: [^self].
	(users byUsername: name andPassword: password)
		ifNotNil: [ :user | ^self loginAs: user].
	message := 'Invalid username or password'.! !

WAComponent subclass: #SPInternalRegistrationComponent
	instanceVariableNames: 'message registry form username password1 password2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:44'!
initialize
	super initialize.
	message := nil.
	registry := SPInternalUser! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:34'!
password1
	^password1! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
password1: aPassword
	password1 := aPassword.! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
password2
	^password2! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
password2: aPassword
	password2 := aPassword.! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:41'!
registerUser
	| user|
	message := nil.
	username isEmptyOrNil ifTrue: [message := 'Please enter a username'. ^self].
	password1 isEmptyOrNil ifTrue: [message := 'Please enter a password'.^self].
	password1 = password2 
		ifFalse: [message := 'Passwords do not match']
		ifTrue: [ user := SPInternalUser named: username.
			user password: password1.
			self answer: (registry addUser: user)]! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:40'!
renderContentOn: html
	self renderMessageOn: html.  
	html form defaultAction: [ self registerUser];
		with: [ |id |
		html label for: (id := html nextId); with: 'Username'.
		html textInput id: id; on: #username of: self.
		html break.
		html label for: (id := html nextId); with: 'Password'.
		html passwordInput id: id; on: #password1 of: self.
		html break.
		html label for: (id := html nextId); with: 'Repeat Password'.
		html passwordInput id: id; on: #password2 of: self.
		html break.
		html submitButton callback: [self registerUser]  ]! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 19:30'!
renderMessageOn: html
	message
		ifNotNil: [ 
			(html paragraph)
				class: 'message';
				with: message ]! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
username
	^username! !

!SPInternalRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:35'!
username: aName
	username := aName! !

WAComponent subclass: #SPSampleRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Sample'!

!SPSampleRoot class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 20:43'!
canBeRoot
	^true! !

!SPSampleRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:41'!
renderContentOn:  html
	| me |
	me := self session platformUser.
	html heading: 'Hello, World'.
	html heading: 'About Me'.
	html image src: me pictureUrl.
	html definitionList:  [
		html
			definitionTerm:  'Name';
			definitionData: me name] .
	html anchor callback: [self session platformLogout ]; with: 'Logout'  ! !

WARenderLoopMain subclass: #SPLoginRenderLoopMain
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

!SPLoginRenderLoopMain commentStamp: 'StuartHerring 10/30/2011 15:37' prior: 0!
"A specialised subclass of WARenderLoopMain to allow a different root component during the login phase of a new session"!

!SPLoginRenderLoopMain class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 19:29'!
withRootClass: aRootComponent
	^self basicNew 
		initializeWithRootClass: aRootComponent;
		yourself.  ! !

!SPLoginRenderLoopMain methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 15:39'!
initializeWithRootClass: aRootComponent
	self initialize.
	root := aRootComponent  ! !

!SPLoginRenderLoopMain methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 16:25'!
rootClass
	^root! !

WASession subclass: #SPSession
	instanceVariableNames: 'platform'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

!SPSession methodsFor: 'private' stamp: 'StuartHerring 9/25/2011 18:11'!
detectPlatform
	^(self preferenceAt: #platforms)  
		detect: [ :p | p supportsRequest: self requestContext request ] 
		ifNone:  [ Error signal: 'No platform found' ]! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 11/13/2011 11:47'!
platformLogout
	" Disassociates the session from the platform user/session"
	platform logout.
	self expire! !

!SPSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 20:55'!
platformUser
	^platform user! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 9/6/2011 21:07'!
setPlatform: aPlatform
	platform := aPlatform! !

!SPSession methodsFor: 'private' stamp: 'StuartHerring 11/19/2011 14:42'!
start
	self setPlatform: (self detectPlatform newFromRequest: self requestContext request).
	platform isLoggedIn ifFalse: [
		(SPLoginRenderLoopMain withRootClass: platform loginComponent) start]
		ifTrue: [ super start]! !

Object subclass: #SPInternalSession
	instanceVariableNames: 'user id date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

SPInternalSession class
	instanceVariableNames: 'sessions'!

SPInternalSession class
	instanceVariableNames: 'sessions'!

!SPInternalSession class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:35'!
byId: aUuidString
	^self sessions at: (UUID fromString: aUuidString) ifAbsent: [nil]! !

!SPInternalSession class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 16:29'!
forUser: aUser
	^self basicNew
		initializeWithUser: aUser;
		yourself! !

!SPInternalSession class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:00'!
registry
	^self! !

!SPInternalSession class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:46'!
removeSession: aSession
	sessions removeKey: aSession id ifAbsent: [ " do nothing"].! !

!SPInternalSession class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:31'!
sessionForUser: aUser
	| s |
	s := self forUser: aUser.
	^self sessions at: s id put: s! !

!SPInternalSession class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 16:52'!
sessions
	^sessions ifNil: [ sessions := Dictionary new ]! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:30'!
cookie
	"Create a new Cookie for this session"
	^WACookie key: SPInternalPlatform cookieName value: id printString! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:21'!
date
	^date! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:21'!
id
	^id! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 10:15'!
initializeWithUser: aUser
	self initialize.
	user := aUser.
	id := UUID new.
	date := DateAndTime current.! !

!SPInternalSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 17:32'!
user
	^user! !

Object subclass: #SPPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

!SPPlatform commentStamp: 'StuartHerring 9/3/2011 12:53' prior: 0!
I am an abstract base class for a social platform.  
A social platform is an API that provides the following services:
* Authentication
* Identity (Basic name and avatar)
* Notification
* Access to contact/connection/friend detail
* A way of publishing information to contacts
* A way of inviting contacts

One instance of a Platform subclass exists for each logged in session, and so the Platform classes also track current session information on the underlying platform.!

SPPlatform subclass: #SPFacebookPlatform
	instanceVariableNames: 'signedRequest graphApi user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Facebook'!

!SPFacebookPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 21:27'!
supportsRequest: aRequest
	^aRequest fields includesKey: 'signed_request'  ! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/25/2011 18:22'!
authorize: aRequestContext
	aRequestContext respond: [ :resp |
		resp
			contentType: WAMimeType textHtml;
			nextPutAll: (WAHtmlCanvas builder
				fullDocument: true;
				rootBlock: [ :root | 
					root title: 'Seaside'; beXhtml10Strict.
					root htmlAttributes at: 'xmlns' put: 'http://www.w3.org/1999/xhtml' ];
				render: [ :html | 	html script:  ('top.location.href=''{1}''' format: {self application authorizeUrl}) ]) ]! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:17'!
graphApi
	^graphApi ifNil: [ 
		signedRequest isAuthorized ifTrue: [ 
			graphApi := FBGraphAPI accessToken: signedRequest oauthToken ]]! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:08'!
initializeWithRequest: aRequest
	super initializeWithRequest: aRequest.
	signedRequest := FBSignedRequest decodeRequest: (aRequest fields at: 'signed_request').
! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:07'!
isLoggedIn
	^signedRequest notNil and: [signedRequest isAuthorized]! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:42'!
loginComponent
	^SPFacebookAuthorizeComponent! !

!SPFacebookPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:38'!
user
	^user ifNil: [ SPFacebookUser graphUser: self graphApi currentUser]! !

SPPlatform subclass: #SPInternalPlatform
	instanceVariableNames: 'sessions cookie session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

!SPInternalPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 17:52'!
cookieName
	^'spinternal'! !

!SPInternalPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/3/2011 14:02'!
supportsRequest: aRequest
	^true  ! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:00'!
initializeWithRequest: aRequest
	super initializeWithRequest: aRequest.
	cookie := aRequest cookieAt: self class cookieName.
	session := nil.
	sessions := SPInternalSession registry! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 16:50'!
isLoggedIn
	^self session notNil! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:42'!
loginComponent
	^SPInternalLoginComponent! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:43'!
logout
	session ifNotNilDo: [ :s | sessions removeSession: s]  ! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:05'!
session
	^session ifNil: [
		cookie ifNotNil: [ session := sessions byId: cookie value]]! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 17:59'!
setSessionRegistry: aSessionRegistry
	sessions := aSessionRegistry! !

!SPInternalPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 17:36'!
user
	^self session isNil ifTrue: [nil]
		ifFalse: [session user]! !

!SPPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 16:10'!
newFromRequest: aRequest
	^self basicNew
		initializeWithRequest: aRequest;
		yourself.    ! !

!SPPlatform class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/6/2011 21:14'!
supportsRequest: aRequest
	"Subclasses should return true if this request represents one from their platform"
	self subclassResponsibility! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 16:09'!
initializeWithRequest: aRequest
	self initialize.  ! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 16:01'!
isLoggedIn
	"Indicate whether or not this platform instance is logged in"
	self subclassResponsibility! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:43'!
loginComponent
	"Subclasses should answer a suitable component or task class to use as the root component during the login phase"
	self subclassResponsibility ! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:42'!
logout
	"Breaks the association between the platform user and the application"
	self subclassResponsibility.! !

!SPPlatform methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:43'!
user
	"Subclasses should return the current logged in user, or nil if not logged in"
	self subclassResponsibility.! !

Object subclass: #SPUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform'!

SPUser subclass: #SPFacebookUser
	instanceVariableNames: 'graphUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Facebook'!

!SPFacebookUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:39'!
graphUser: aUser
	^self basicNew
		initializeWithGraphUser: aUser;
		yourself.! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:24'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ graphUser = (anObject instVarNamed: #graphUser)! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/19/2011 14:13'!
hash
	^graphUser hash! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:39'!
initializeWithGraphUser: aUser  
	self initialize.
	graphUser := aUser! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:44'!
name
	^graphUser name! !

!SPFacebookUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 22:45'!
pictureUrl
	^graphUser pictureUrl! !

SPUser subclass: #SPInternalUser
	instanceVariableNames: 'name password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Platform-Internal'!

SPInternalUser class
	instanceVariableNames: 'users'!

SPInternalUser class
	instanceVariableNames: 'users'!

!SPInternalUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:44'!
addUser: aUser
	^users at: aUser name put: aUser.! !

!SPInternalUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:46'!
byUsername: aName andPassword:  aPassword
	^self users at: aName ifPresent: [ :u | (u checkPassword: aPassword) ifTrue: [u]]! !

!SPInternalUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:37'!
defaultPictureUrl
	^'about:blank'! !

!SPInternalUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 19:30'!
named: aName
	^self basicNew
		initializeWithName: aName;
		yourself  ! !

!SPInternalUser class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 18:22'!
users
	^users ifNil: [ users := Dictionary new].! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:46'!
checkPassword: aPassword
	^password = aPassword  ! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 19:40'!
initializeWithName: aName
	self initialize.
	name := aName.  ! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 10/30/2011 19:49'!
name
	^name! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/6/2011 23:43'!
password: aPassword
	password := aPassword! !

!SPInternalUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 11/13/2011 11:37'!
pictureUrl
	^self class defaultPictureUrl! !

!SPUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 21:04'!
id
	self subclassResponsibility! !

!SPUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 21:03'!
name
	self subclassResponsibility! !

!SPUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 21:04'!
pictureUrl
	self subclassResponsibility! !
